> This page is for Unified.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.merge.dev/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.merge.dev/_mcp/server.

# /custom-object-classes/{custom_object_class_id}/association-types

POST https://api.merge.dev/api/crm/v1/custom-object-classes/{custom_object_class_id}/association-types
Content-Type: application/json

Creates an `AssociationType` object with the given values.

Reference: https://docs.merge.dev/merge-unified/crm/custom-objects/association-types/custom-object-classes-association-types-list

## Authentication

- `Authorization` header (bearer token, required) — Token-based authentication with required prefix "Bearer"

## Servers

- `https://api.merge.dev/api` (Production, default)
- `https://api-eu.merge.dev/api` (ProductionEU)
- `https://api-ap.merge.dev/api` (ProductionAPSE1)

## Request

### Path parameters

- `custom_object_class_id` (string, required)

### Query parameters

- `is_debug_mode` (boolean, optional) — Whether to include debug fields (such as log file links) in the response.
- `run_async` (boolean, optional) — Whether or not third-party updates should be run asynchronously.

### Headers

- `X-Account-Token` (string, required) — Token identifying the end user.

### Body (application/json)

This endpoint expects a CRMAssociationTypeEndpointRequest.

- `model` (AssociationTypeRequestRequest, required)

## Response

### 201

- `model` (AssociationType, required) — # The AssociationType Object ### Description The `Association Type` object represents the relationship between two objects. ### Usage Example TODO
- `warnings` (list of WarningValidationProblem, required)
- `errors` (list of ErrorValidationProblem, required)
- `logs` (list of DebugModeLog, optional)

## Types

### AssociationTypeRequestRequest

- `source_object_class` (ObjectClassDescriptionRequest, required)
- `target_object_classes` (list of ObjectClassDescriptionRequest, required)
- `remote_key_name` (string, required)
- `display_name` (string, optional)
- `cardinality` (enum, optional)
  - Allowed values: `ONE_TO_ONE`, `MANY_TO_ONE`, `MANY_TO_MANY`, `ONE_TO_MANY`
- `is_required` (boolean, optional, default: false)

### AssociationType

# The AssociationType Object ### Description The `Association Type` object represents the relationship between two objects. ### Usage Example TODO

- `id` (string, optional)
- `remote_id` (string, optional, nullable) — The third-party API ID of the matching object.
- `created_at` (datetime, optional) — The datetime that this object was created by Merge.
- `modified_at` (datetime, optional) — The datetime that this object was modified by Merge.
- `source_object_class` (map from string to any, optional) — The class of the source object (Custom Object or Common Model) for the association type.
- `target_object_classes` (list of AssociationSubType, optional)
- `remote_key_name` (string, optional, nullable)
- `display_name` (string, optional, nullable)
- `cardinality` (enum, optional, nullable)
  - Allowed values: `ONE_TO_ONE`, `MANY_TO_ONE`, `MANY_TO_MANY`, `ONE_TO_MANY`
- `is_required` (boolean, optional)

### WarningValidationProblem

- `title` (string, required)
- `detail` (string, required)
- `problem_type` (string, required)
- `source` (ValidationProblemSource, optional)
- `block_merge_link` (boolean, optional)
- `raw_error` (string, optional)
- `error_code` (integer, optional)

### ErrorValidationProblem

- `title` (string, required)
- `detail` (string, required)
- `problem_type` (string, required)
- `source` (ValidationProblemSource, optional)
- `block_merge_link` (boolean, optional)
- `raw_error` (string, optional)
- `error_code` (integer, optional)

### DebugModeLog

- `log_id` (string, required)
- `dashboard_view` (string, required)
- `log_summary` (DebugModelLogSummary, required)

### ObjectClassDescriptionRequest

- `id` (string, required)
- `origin_type` (enum, required)
  - Allowed values: `CUSTOM_OBJECT`, `COMMON_MODEL`, `REMOTE_ONLY_MODEL`

### AssociationSubType

- `id` (string, optional, nullable)
- `created_at` (datetime, optional) — The datetime that this object was created by Merge.
- `modified_at` (datetime, optional) — The datetime that this object was modified by Merge.
- `origin_type` (string, optional, nullable)

### ValidationProblemSource

- `pointer` (string, required)

### DebugModelLogSummary

- `url` (string, required)
- `method` (string, required)
- `status_code` (integer, required)

## Examples

**Request**

```json
{
  "model": {
    "source_object_class": {
      "id": "string",
      "origin_type": "CUSTOM_OBJECT"
    },
    "target_object_classes": [
      {
        "id": "string",
        "origin_type": "CUSTOM_OBJECT"
      }
    ],
    "remote_key_name": "string"
  }
}
```

**Response**

```json
{
  "model": {
    "id": "5bb73c32-3c6c-4757-ab7d-7d3540a1be31",
    "remote_id": "93",
    "created_at": "2021-09-15T00:00:00Z",
    "modified_at": "2021-10-16T00:00:00Z",
    "source_object_class": {
      "id": "ff1ff4cb-a66b-47dc-8e2a-50388049e602",
      "origin_type": "CUSTOM_OBJECT"
    },
    "target_object_classes": [
      {
        "id": "Opportunity",
        "origin_type": "COMMON_MODEL"
      }
    ],
    "remote_key_name": "order_to_opportunity",
    "display_name": "Order to Opportunity",
    "cardinality": "ONE_TO_MANY",
    "is_required": true
  },
  "warnings": [
    {
      "title": "Unrecognized Field",
      "detail": "An unrecognized field, age, was passed in with request data.",
      "problem_type": "UNRECOGNIZED_FIELD",
      "source": {
        "pointer": "/age"
      },
      "block_merge_link": true,
      "raw_error": "string",
      "error_code": 1
    }
  ],
  "errors": [
    {
      "title": "Missing Required Field",
      "detail": "custom_fields is a required field on model.",
      "problem_type": "MISSING_REQUIRED_FIELD",
      "source": {
        "pointer": "/model/custom_fields"
      },
      "block_merge_link": true,
      "raw_error": "string",
      "error_code": 1
    }
  ],
  "logs": [
    {
      "log_id": "99433219-8017-4acd-bb3c-ceb23d663832",
      "dashboard_view": "https://app.merge.dev/logs/99433219-8017-4acd-bb3c-ceb23d663832",
      "log_summary": {
        "url": "www.exampleintegration.com/api/v1/exampleapi",
        "method": "POST",
        "status_code": 200
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types"

payload = { "model": {
        "source_object_class": {
            "id": "string",
            "origin_type": "CUSTOM_OBJECT"
        },
        "target_object_classes": [
            {
                "id": "string",
                "origin_type": "CUSTOM_OBJECT"
            }
        ],
        "remote_key_name": "string"
    } }
headers = {
    "X-Account-Token": "X-Account-Token",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types';
const options = {
  method: 'POST',
  headers: {
    'X-Account-Token': 'X-Account-Token',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: '{"model":{"source_object_class":{"id":"string","origin_type":"CUSTOM_OBJECT"},"target_object_classes":[{"id":"string","origin_type":"CUSTOM_OBJECT"}],"remote_key_name":"string"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types"

	payload := strings.NewReader("{\n  \"model\": {\n    \"source_object_class\": {\n      \"id\": \"string\",\n      \"origin_type\": \"CUSTOM_OBJECT\"\n    },\n    \"target_object_classes\": [\n      {\n        \"id\": \"string\",\n        \"origin_type\": \"CUSTOM_OBJECT\"\n      }\n    ],\n    \"remote_key_name\": \"string\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Account-Token", "X-Account-Token")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Account-Token"] = 'X-Account-Token'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"model\": {\n    \"source_object_class\": {\n      \"id\": \"string\",\n      \"origin_type\": \"CUSTOM_OBJECT\"\n    },\n    \"target_object_classes\": [\n      {\n        \"id\": \"string\",\n        \"origin_type\": \"CUSTOM_OBJECT\"\n      }\n    ],\n    \"remote_key_name\": \"string\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types")
  .header("X-Account-Token", "X-Account-Token")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"model\": {\n    \"source_object_class\": {\n      \"id\": \"string\",\n      \"origin_type\": \"CUSTOM_OBJECT\"\n    },\n    \"target_object_classes\": [\n      {\n        \"id\": \"string\",\n        \"origin_type\": \"CUSTOM_OBJECT\"\n      }\n    ],\n    \"remote_key_name\": \"string\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types', [
  'body' => '{
  "model": {
    "source_object_class": {
      "id": "string",
      "origin_type": "CUSTOM_OBJECT"
    },
    "target_object_classes": [
      {
        "id": "string",
        "origin_type": "CUSTOM_OBJECT"
      }
    ],
    "remote_key_name": "string"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Account-Token' => 'X-Account-Token',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Account-Token", "X-Account-Token");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"model\": {\n    \"source_object_class\": {\n      \"id\": \"string\",\n      \"origin_type\": \"CUSTOM_OBJECT\"\n    },\n    \"target_object_classes\": [\n      {\n        \"id\": \"string\",\n        \"origin_type\": \"CUSTOM_OBJECT\"\n      }\n    ],\n    \"remote_key_name\": \"string\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Account-Token": "X-Account-Token",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["model": [
    "source_object_class": [
      "id": "string",
      "origin_type": "CUSTOM_OBJECT"
    ],
    "target_object_classes": [
      [
        "id": "string",
        "origin_type": "CUSTOM_OBJECT"
      ]
    ],
    "remote_key_name": "string"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.merge.dev/api/crm/v1/custom-object-classes/custom_object_class_id/association-types")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```